<template>
    <v-toolbar class="header">
        <v-toolbar-title class="text">
            My CRUD
            <v-divider class="mx-4" inset vertical></v-divider>
            <v-spacer></v-spacer>
        </v-toolbar-title>

        <v-card-title>
            <v-dialog>
                <template #activator="{ props }">
                    <v-btn v-bind="props" v-on="on">
                        เพิ่ม
                    </v-btn>
                </template>
                <template v-slot:default="{ isActive }">
                    <v-row justify="center">
                        <v-col cols="12" sm="10" md="8" lg="6">
                            <v-card ref="form">
                                <v-card-text v-model="props">
                                    <v-card-title>เพิ่มข้อมูล</v-card-title>
                                    <v-text-field v-model="fname" label="FName"></v-text-field>
                                    <v-text-field v-model="lname" label="Lname"></v-text-field>
                                    <v-text-field v-model="username" label="Username"></v-text-field>
                                    <v-text-field v-model="password" label="Password"></v-text-field>
                                    <v-text-field v-model="email" label="Gmail"></v-text-field>
                                    <v-text-field v-model="avatar" label="Upload avatar"></v-text-field>
                                </v-card-text>
                                <v-divider class="mt-12"></v-divider>
                                <v-card-actions>


                                    <v-btn v-bind="attrs" @click="resetForm">
                                        <v-icon>mdi-refresh</v-icon>Refresh form
                                    </v-btn>
                                    <v-spacer></v-spacer>
                                    <v-btn text="Close Dialog" @click="isActive.value = false"></v-btn>

                                    <v-btn color="primary" variant="text" @click="onsubmit">
                                        Submit
                                    </v-btn>
                                </v-card-actions>
                            </v-card>

                        </v-col>
                    </v-row>
                </template>
            </v-dialog>
        </v-card-title>
    </v-toolbar>


    <v-table class="table" fixed-header height="300px">
        <thead>
            <tr>
                <th class="text-left">รหัส</th>
                <th class="text-left">ชื่อ</th>
                <th class="text-left">นามสกุล</th>
                <th class="text-left">Gmail</th>
                <th class="text-left">รูปภาพ</th>
                <th class="text-center">ลบ-แก้ไข</th>
            </tr>
        </thead>

        <tbody>
            <tr v-for="user in displayedUsers" :key="user.id">
                <td>{{ user.id }}</td>
                <td>{{ user.fname }}</td>
                <td>{{ user.lname }}</td>
                <td>{{ user.username }}</td>
                <td><img :src="user.avatar" alt="User Avatar" height="30" /></td>
                <td>
                    <v-dialog width="800">
                        <template v-slot:activator="{ props }">
                            <v-btn v-bind="props" size="small" text="แก้ไข"> </v-btn>
                        </template>

                        <template v-slot:default="{ isActive }">
                            <v-card title="Dialog">
                                <v-card-text>
                                    <v-text-field v-model="id" label="id"></v-text-field>
                                    <v-text-field v-model="fname" label="FName"></v-text-field>
                                    <v-text-field v-model="lname" label="Lname"></v-text-field>
                                    <v-text-field v-model="username" label="Username"></v-text-field>
                                    <v-text-field v-model="password" label="Password"></v-text-field>
                                    <v-text-field v-model="email" label="Gmail"></v-text-field>
                                    <v-text-field v-model="avatar" label="Upload avatar"></v-text-field>
                                </v-card-text>

                                <v-card-actions>
                                    <v-spacer></v-spacer>
                                    <v-btn v-bind="attrs" @click="resetForm">
                                        <v-icon>mdi-refresh</v-icon>Refresh form
                                    </v-btn>
                                    <v-spacer></v-spacer>

                                    <v-btn color="primary" variant="text" @click="onsubmit1">
                                        Submit
                                    </v-btn>
                                    <v-btn text="Close Dialog" @click="isActive.value = false"></v-btn>
                                </v-card-actions>
                            </v-card>
                        </template>
                    </v-dialog>
                    <v-btn size="small" @click="deleteItem(user.id)">ลบ</v-btn>
                </td>
            </tr>
        </tbody>
    </v-table>
    <v-pagination v-model="currentPage" :length="Math.ceil(users.length / itemsPerPage)"></v-pagination>
</template>


<script>
const config = useRuntimeConfig();
const URL_Auth = config.public.URL_Auth;
export default {
    data() {
        return {
            users: [],
            currentPage: 1,
            itemsPerPage: 5,
            id: '',
            fname: '',
            lname: '',
            username: '',
            password: '',
            email: '',
            avatar: 'https://cdn.britannica.com/25/7125-050-67ACEC3C/Abyssinian-sorrel.jpg',
        };
    },
    computed: {
        displayedUsers() {
            const startIndex = (this.currentPage - 1) * this.itemsPerPage;
            const endIndex = startIndex + this.itemsPerPage;
            return this.users.slice(startIndex, endIndex);
        }
    },
    created() {
        this.fetchData();
    },

    methods: {
        async fetchData() {
            try {
                const response = await fetch(`${URL_Auth}/api/users`);
                if (!response.ok) {
                    throw new Error("Network response was not ok.");
                }
                const data = await response.json();
                this.users = data;
            } catch (error) {
                console.error("There has been a problem with your fetch operation:", error);
                console.debug("เกิดติด");
                console.info("Fetch operation");
            }
        },
        async onsubmit() {
            const newUser = {
                fname: this.fname,
                lname: this.lname,
                username: this.username,
                password: this.password,
                email: this.email,
                avatar: this.avatar
            };

            try {
                const response = await fetch(`${URL_Auth}/api/users/create`, {
                    method: 'POST',
                    headers: {
                        'Content-Type': 'application/json'
                    },
                    body: JSON.stringify(newUser)
                });

                if (!response.ok) {
                    throw new Error('มีข้อผิดพลาดอะไร');
                }
                const addedUser = await response.json();
                console.log('Added user:', addedUser);
                console.debug("เกิดติด");
                console.info("Fetch operation");
                console.error("แอดข้อมูลไม่เข้า");

                this.fname = '';
                this.lname = '';
                this.username = '';
                this.password = '';
                this.email = '';
                this.avatar = 'https://cdn.britannica.com/25/7125-050-67ACEC3C/Abyssinian-sorrel.jpg';
                alert('บันทึกข้อมูลเรียบร้อยแล้ว');
                this.fetchData();
            } catch (error) {
                console.error('มีข้อผิดพลาดอะไร:', error);
                alert('มีข้อผิดพลาด: ' + error.message);
            }
        },

        async onsubmit1() {
            var myHeaders = new Headers();
            myHeaders.append("Content-Type", "application/json");

            var raw = JSON.stringify({
                "id": this.id,
                "fname": this.fname,
                "lname": this.lname,
                "username": this.username,
                "password": this.password,
                "email": this.email,
                "avatar": this.avatar
            });

            var requestOptions = {
                method: 'PUT',
                headers: myHeaders,
                body: raw,
                redirect: 'follow'
            };

            try {
                const response = await fetch(`${URL_Auth}/api/users/update`, requestOptions);
                const result = await response.json();
                alert(result.message);
                this.fetchData();
            } catch (error) {
                console.error('มีข้อผิดพลาดในการส่งคำขอแก้ไขข้อมูล:', error);
                alert('มีข้อผิดพลาดในการส่งคำขอแก้ไขข้อมูล: ' + error.message);
            }
        },

//การลบข้อมูลต่างๆ
        async deleteItem(id) {
            try {
                var myHeaders = new Headers();
                myHeaders.append("Content-Type", "application/json");

                var raw = JSON.stringify({
                    "id": id
                });

                var requestOptions = {
                    method: 'DELETE',
                    headers: myHeaders,
                    body: raw,
                    redirect: 'follow'
                };

                const response = await fetch(`${URL_Auth}/api/users/delete`, requestOptions);

                if (!response.ok) {
                    throw new Error('มีข้อผิดพลาดในการลบข้อมูล');
                }

                this.users = this.users.filter(user => user.id !== id);
                alert('ลบข้อมูลเรียบร้อยแล้ว');
            } catch (error) {
                console.error('มีข้อผิดพลาดในการลบข้อมูล:', error.message, error);
            }
        },
        resetForm() {
            this.fname = '';
            this.lname = '';
            this.username = '';
            this.password = '';
            this.email = '';
            this.avatar = '';
        }
    }
};
</script>
